package com.aspirecn.xiaoxuntong.widget

import android.content.Context
import androidx.databinding.DataBindingUtil
import androidx.databinding.ViewDataBinding
import android.text.TextUtils
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import android.widget.*
import com.aspirecn.xiaoxuntong.R
import com.aspirecn.xiaoxuntong.databinding.TopktBinding


class TopBar1 : RelativeLayout {
    companion object {
        val MODE_MAIN_SCREEN = 0
        val MODE_NORMAL_SCREEN = 1
        val MODE_WEB_SCREEN = 2
        // 中间页面切换样式
        val MODE_MIDLE_PAGE_TAB = 3
        // 照片浏览页面样式
        val MODE_PHOTO_BROWSER_SCREEN = 4
        //H5访问时 返回+一键退出
        val MODE_DIRECT_EXIT = 5
    }

    var screenWidth: Int = 0
    var marginDimen: Int = 0
    var binding: TopktBinding? = null

    constructor(context: Context) : super(context) {
        init(context)
    }

    constructor(context: Context, attrs: AttributeSet) : super(context, attrs) {
        init(context)
    }

    constructor (context: Context, attrs: AttributeSet, defStyleAttr: Int) : super(context, attrs, defStyleAttr) {

        init(context)
    }

    private fun init(context: Context) {
        screenWidth = context.resources.displayMetrics.widthPixels
        marginDimen = context.resources.getDimensionPixelSize(R.dimen.top_bar_margin)
        val inflater = context.getSystemService(Context.LAYOUT_INFLATER_SERVICE) as LayoutInflater
        binding = DataBindingUtil.inflate(inflater, R.layout.topkt, this, true)


        /* if (isInEditMode) {
             return
         }*/
    }

    fun setMode(mode: Int) {
        binding?.exitTv?.setVisibility(View.GONE)

        if (mode == MODE_MAIN_SCREEN) {
            binding?.actionListBtn?.setVisibility(View.VISIBLE)
            binding?.leftBtn?.setVisibility(View.GONE)
            binding?.rightBtn?.setVisibility(View.GONE)
            binding?.webBackRlayout?.setVisibility(View.GONE)
        } else if (mode == MODE_NORMAL_SCREEN) {
            binding?.actionListBtn?.setVisibility(View.GONE)
            binding?.leftBtn?.setVisibility(View.VISIBLE)
            binding?.rightBtn?.setVisibility(View.VISIBLE)
            binding?.webBackRlayout?.setVisibility(View.GONE)
            binding?.titleLl?.setVisibility(View.VISIBLE)
            binding?.middlePageTabLl?.setVisibility(View.GONE)

        } else if (mode == MODE_WEB_SCREEN) {
            binding?.actionListBtn?.setVisibility(View.GONE)
            binding?.leftBtn?.setVisibility(View.GONE)
            binding?.rightBtn?.setVisibility(View.GONE)
            binding?.webBackRlayout?.setVisibility(View.VISIBLE)
        } else if (mode == MODE_MIDLE_PAGE_TAB) {

            binding?.titleLl?.setVisibility(View.GONE)
            binding?.middlePageTabLl?.setVisibility(View.VISIBLE)
            binding?.leftBtn?.setVisibility(View.VISIBLE)
            binding?.rightBtn?.setVisibility(View.VISIBLE)

        } else if (mode == MODE_PHOTO_BROWSER_SCREEN) {
            binding?.titleLl?.setVisibility(View.GONE)
            binding?.albumBrowserLl?.setVisibility(View.VISIBLE)
            binding?.leftBtn?.setVisibility(View.VISIBLE)
        } else if (mode == MODE_DIRECT_EXIT) {
            binding?.actionListBtn?.setVisibility(View.GONE)
            binding?.leftBtn?.setVisibility(View.VISIBLE)
            binding?.rightBtn?.setVisibility(View.VISIBLE)
            binding?.webBackRlayout?.setVisibility(View.GONE)
            binding?.titleLl?.setVisibility(View.VISIBLE)
            binding?.middlePageTabLl?.setVisibility(View.GONE)
            binding?.exitTv?.setVisibility(View.VISIBLE)
        }
    }

    fun getTitle(): TextView? = binding?.title
    fun getLeftBtn(): ImageView? = binding?.leftBtn
    fun getLeftLayout(): RelativeLayout? = binding?.leftBtnRlayout
    fun getRightBtn(): ImageView? = binding?.rightBtn
    fun getRightLayout(): RelativeLayout? = binding?.rightBtnRlayout
    fun getRighTextView(): TextView? = binding?.tipMessageTv
    fun setRightTextViewContent(content: String) {
        if (!TextUtils.isEmpty(content)) {
            binding?.tipMessageTv?.setVisibility(View.VISIBLE);
            binding?.tipMessageTv?.setText(content);
        } else {
            binding?.tipMessageTv?.setVisibility(View.GONE);
        }
    }

    fun getLeftTextView(): TextView? = binding?.tipCancelTv
    fun getPageTabCbLeft(): CheckBox? = binding?.pageTabCb1
    fun getPageTabCbRight(): CheckBox? = binding?.pageTabCb2
    fun getSubjectTypeSpinner(): Spinner? = binding?.subjectTypeChooseSp
    fun getSubjectTypeSpinnerArrow(): ImageView? = binding?.subjectTypeChooseArrow

    fun getAllContact(): TextView? = binding?.selectedGroupNameTv

    override fun onAttachedToWindow() {
        super.onAttachedToWindow()

        try {
            binding?.leftBtnRlayout?.measure(0, 0);
            binding?.webBackRlayout?.measure(0, 0);
            binding?.titleAdditional?.measure(0, 0);
            binding?.rightBtnRlayout?.measure(0, 0);

            var max: Int = Math.max(binding?.webBackRlayout!!.getMeasuredWidth(), binding?.leftBtnRlayout!!.getMeasuredWidth());
            var rightMax = Math.max(max, binding?.rightBtnRlayout!!.getMeasuredWidth());
            var maxpixels = screenWidth - max - rightMax - binding?.titleAdditional!!.getMeasuredWidth() - 2 * marginDimen;
            binding?.title!!.setMaxWidth(maxpixels);

        } catch (e: Exception) {
            e.printStackTrace();
        }
    }

    fun getHomeLayout(): RelativeLayout = binding?.homeBgLayout!!
    fun getExit(): TextView = binding?.exitTv!!

}